var programs = {
	opened_program:false,
	open: function(event) {
		event.stopPropagation();
		if(layout.program_visible) {
			layout.hideProgram();
			return;
		}
		
		$('.activesidebarbutton').removeClass('activesidebarbutton');
		$(this).addClass('activesidebarbutton');
		
		var id = $(this).attr('programid');
		layout.showProgram();
		
		var program = db.getProg(id, programs.drawProgram);
	},
	drawProgram: function(program) {
		programs.opened_program = program;
		$('#codearea').val(program['code']);
		programs.drawTurtle(program['code'], layout.displayMainTurtleImage);
	},
	add: function(event) {
		event.stopPropagation();
		if(layout.program_visible) {
			layout.hideProgram();
			return;
		}
		db.addProg(function() {
			layout.redrawProgramList();
		});
	},
	codeChanged: function() {
		var code = $('#codearea').val();
		if(code == programs.opened_program['code']) return;
		setTimeout(function() {
			if(code == $('#codearea').val()) {
				programs.storeCode();
				programs.drawTurtle(code, layout.displayMainTurtleImage)
			}
		},300);
	},
	storeCode: function() {
		db.updateProg(programs.opened_program['id'], programs.opened_program['name'], $('#codearea').val());
	},
	backgroundTap: function(event) {
		event.stopPropagation();
		if(layout.program_visible) {
			programs.storeCode();
			layout.hideProgram();
			programs.opened_program = false;
		}
	},
	drawTurtle: function(code, callback, width, height) {
		if(!width) width = '';
		if(!height) height = '';
		$.post(
			"/logo.php",
			{
				code: code,
				width: width,
				height: height
			},
			function(data){
				callback(data['warnings'],data['imagename'],data['width'],data['height']);
			}
		);
	}
}