<?php
	// Based on logoparser/sample.php by Zhihua Lai
	$domainpath = '/var/www/domains/turtle.lkmc.ch/';

	include $domainpath."logoparser/logo.php";
	include $domainpath."logoparser/class.logo.parser.php";
	
	$width = 1024;
	$height = 768;
	
	$zoomwidth = false;
	$zoomheight = false;
	if($_POST['width'] && is_numeric($_POST['width'])) {
		$zoomwidth = $_POST['width'];
	}
	if($_POST['height'] && is_numeric($_POST['height'])) {
		$zoomheight = $_POST['height'];
	}

	$im = @imagecreatetruecolor($width, $height); 
	$canvas=new Logo(&$im, 255, 255, 255);
	$canvas->setWrap(LOGO_WINDOW);
	$textcolor = ImageColorAllocate($im, 0 ,0, 0);  
	$canvas->setPC($textcolor);
	$canvas->pd();

	$code = $_POST['code'];
	//$code="repeat 5 [fd 100 rt 144]"; 

	$parser=new LogoParser(&$canvas);
	$ret=$parser->parse(($code));
	
	$warnings=$parser->printWarnings();

	$name = uniqid('turtle').'.png';
	
	if($zoomwidth && $zoomheight) {
		$thumb = imagecreatetruecolor($zoomwidth, $zoomheight);
		//imagecopyresized($thumb, $im, 0, 0, 0, 0, $zoomwidth, $zoomheight, $width, $height);
		imagecopyresampled($thumb, $im, 0, 0, 0, 0, $zoomwidth, $zoomheight, $width, $height);
		//imagefilter($thumb, IMG_FILTER_CONTRAST, -100);
		imagepng($thumb, $domainpath."tmp/".$name);
		imagedestroy($thumb);
		
		$width = $zoomwidth;
		$height = $zoomheight;
	} else {
		imagepng($im, $domainpath."tmp/".$name);
	}
	imagedestroy($im);
	
	header("Content-Type: application/json");
?>{
"warnings": <?php echo(json_encode($warnings)); ?>, 
"imagename": <?php echo(json_encode($name)); ?>,
"width": <?php echo(json_encode($width)); ?>,
"height": <?php echo(json_encode($height)); ?>
}